#import <Cocoa/Cocoa.h>
#import "ARFiley.h"

@interface ARFile : NSObject <ARFiley> {
	@private
	IconRef icon;
	FSRef fsref;
	BOOL madeFsref;
	BOOL fsrefFailed;
	LSItemInfoRecord itemInfo;

	NSString *_path;
	NSDictionary *_attributes;
	NSNumber *_finderAlias;
}
@property (retain) NSString *path;
@property (retain, nonatomic) NSDictionary *attributes;
@property (readonly, getter=isFinderAlias) BOOL finderAlias;
@property (readonly, getter=isSymbolicLink) BOOL symbolicLink;

+ (BOOL) setPermissions:(int) permissions path:(NSString*) path;
+ (NSString *) getHomeDirectory:(NSString*) username;

+ (ARFile*) fileWithPath: (NSString*) path;
- initWithPath:(NSString *) path;
- initWithFSRef:(FSRef) ref;

- (BOOL) conformsTo:(NSString *) uti;

// So it can be called from elsewhere
+ (BOOL) isImageUti:(NSString*) uti;

// Files on network volumes can't be trashed, for example - you need to just delete them (which this won't do)
- (BOOL) trashIfPossible;

// This will delete if it can't trash
- (BOOL) trashOrDelete;

- (void) setTypeCode:(NSString*) typeCode;

// Should be in ARFiley?
- (NSData*) getIconData:(int) width pad:(BOOL) pad;

@end
