#import <Foundation/Foundation.h>
#import "NoRetain.h"

@interface Callbacks : NSObject {
	NoRetainArray *targets;
	NSMutableSet * _swizzledClasses;
}
@end

@interface Callback : NSObject {
	NSInvocation *invocation;
	int oneOffArgCount, permanentArgCount;
	NSMutableArray *objectArguments;
	NSMutableArray *permanentObjectArguments;
	BOOL singleUse;
	BOOL called;
}

@property (assign) BOOL singleUse;

- (void) addPermanentArgumentPointer:(void*) arg;
- (void) addPermanentArgumentObject:(id) arg;
- (void) addArgumentObject:(id) arg;
- (void) addArgumentPointer:(void*) arg;
- (id) target;
- (void) invoke;
- (void) invokeWithObject:(id) arg;
- (void) invokeWithBoolean:(BOOL) b;
- (void) invokeWithFloat:(float) f;
- (void) getReturnValue:(void *)buffer;
@end


Callback* CB(id target, SEL selector);
Callback* CallbackWithObjectArgument(id target, SEL selector, id arg);