#import <Foundation/Foundation.h>

// Cocoa doesn't like you throwing non-exceptions, so use this
#define ThrowString(...) [NSException raise:@"UnnamedException" format:__VA_ARGS__]

#define FSNestedError @"FSNestedError"
#define FSNestedException @"FSNestedException"
#define ThrowNestedError(e, ...) @throw [NSException exceptionWithName:@"UnnamedException" reason:Fmt(__VA_ARGS__) userInfo:[NSDictionary dictionaryWithObject:(e) forKey:FSNestedError]]
#define ThrowNestedException(e, ...) @throw [NSException exceptionWithName:@"UnnamedException" reason:Fmt(__VA_ARGS__) userInfo:[NSDictionary dictionaryWithObject:(e) forKey:FSNestedException]]


@interface NSException (ExceptionAdditions)
@property (readonly) NSError *nestedError;
@property (readonly) NSException *nestedException;
@end

@interface NSError (ExceptionAdditions)
+ (NSError*) errorWithTitle:(NSString*) title description:(NSString*) description;
+ (NSError*) errorWithTitle:(NSString*) title description:(NSString*) description userInfo:(NSDictionary*) moreUserInfo;
+ (NSError *) errorWithCode:(int) code title:(NSString *) title description:(NSString *) description;
+ (NSError *) errorWithCode:(int) code title:(NSString *) title description:(NSString *) description userInfo:(NSDictionary *) moreUserInfo;


@end
