#import "StreamAdditions.h"

/*
 Serialisation Notes
 
 Currently we don't support object references in these C files, although the Java does. Should be fairly straightforward.
 */
@interface OldSerialiser : NSObject {
	@private
	BlockingOutputStream *os;
	BOOL withAllClassIndicators;
}
@property (assign) BOOL withAllClassIndicators;

+ (NSData*) writeObject:(NSObject*) obj;
- initWithOutputStream:(BlockingOutputStream*) o;

- (void) writeValue:(NSObject*) value ofType:(NSString*) type;
- (void) writeValue:(uint8_t*) value ofTypeEncoding:(const char*) typeEncoding;
- (void) writeData:(NSData*) d;
- (void) writeDate:(NSDate*) d;
- (void) writeList:(NSArray*) a;
- (void) writeString:(NSString*) str;
- (void) writeBool:(BOOL) b;
- (void) writeByte:(UInt8) i;
- (void) writeShort:(UInt16) i;
- (void) writeInt:(UInt32) i;
- (void) writeLong:(UInt64) i;

@end
